import PyLR.Lexer, re, string
Lexer = PyLR.Lexer

def idfunc(m):
    return string.atoi(m.group(0))

class mathlex(Lexer.Lexer):

    ID = r"([1-9]([0-9]+)?)|0"
    LPAREN = r"\("
    RPAREN = r"\)"
    
    TIMES = r"\*"
    PLUS = r"\+"
    WS = r"\s+"


    def __init__(self):
	Lexer.Lexer.__init__(self)
	self.addpat(self.ID, "ID", idfunc)
	for p,t in ( (self.PLUS, "PLUS"), (self.TIMES,"TIMES"),
		     (self.LPAREN, "LPAREN"), (self.RPAREN, "RPAREN"),):
	    self.addpat(p,t)
	self.addpat(self.WS, "", None, Lexer.SKIPTOK)
	self.compile()
	



