
__version__ = "$Id: Parser.py,v 0.1 1997/12/08 09:23:42 scott Exp scott $"

import  PyLRengine


class Parser:

    def __init__(self, lexer, actiontable, gototable, prodinfo):
	self.lexer = lexer
	self.actions = actiontable
	self.gotos = gototable
	self.prodinfo = prodinfo
	self.engine = None
	prodfuncs = {}
	pi = 0
	for t in prodinfo:
	    if hasattr(self, t[1]):
		newf = getattr(self, t[1])
	    else:
		newf = self.__dummy
	    prodinfo[pi]=(t[0], newf, t[2])
	    pi = pi + 1


    def __dummy(*args):
	    return args[1]


    def initengine(self, dodel=0):
	self.engine = PyLRengine.NewEngine(self.prodinfo, self.actions, self.gotos)
	if dodel:
	    self.actions = []
	    self.gotos = []
	    self.prodinfo = []

    def parse(self, text):
	self.initengine()
	self.lexer.settext(text)
	while 1:
	    tok, val = self.lexer.scan()
	    if not self.engine.parse(tok, val):
		break
	#
	# need to add a method to the engine to
	# return the final value
	# and return that here
	#
	return None

    
